property spr, mem, spr2, mem2
property interessados
property velMax, velMin, puloMax
property linhaAtual, linhaMax
property numLinhas
property alturaLinha, linhasJanela
property numLinhas2
property ultimoScroll, lastOut
property areaSensivel
property ligado, modificouCursor
property numCursor
property scrolou

on getPropertyDescriptionList
  set p_list = [ ¬
    #alturaLinha: [ #comment: "Altura (em pixels) de cada linha (0 p/ nao alterar)", ¬
               #format:  #integer,¬
               #default: 16 ],¬
    #velMax: [ #comment: "Velocidade maxima(pix/s)", ¬
               #format:  #integer,¬
               #default: 96 ],¬
    #velMin: [ #comment: "Velocidade minima(pix/s)", ¬
               #format:  #integer,¬
               #default: 16 ],¬
    #puloMax: [ #comment: "Maior pulo do scroll (em pixels)", ¬
               #format:  #integer,¬
               #default: 16 ],¬
    #interessados: [ #comment: "Sprites que se interessam pelo scroll:", ¬
               #format:   #list, ¬
               #default: [] ],¬
    #areaSensivel: [ #comment: "Area sensivel (em pixels)", ¬
               #format:  #integer,¬
               #default: 48 ]¬
  ]
  return p_list
end

on beginSprite me
  set spr = the spriteNum of me
  set spr2 = spr + 1
  set mem = the member of sprite spr
  set mem2 = the member of sprite spr2
  set linhaAtual = 0
  set numLinhas = the lineCount of member mem
  set numLinhas2 = the lineCount of member mem2
  if alturaLinha = 0 then
    set alturaLinha =  lineheight(mem, 1)
  else
    set the lineHeight of member mem to alturaLinha
    set the lineHeight of member mem2 to alturaLinha
  end if
  set linhasJanela = the height of sprite spr / alturaLinha
  set linhaMax = numLinhas + numLinhas2 - 10
  if linhaMax < 0 then set linhaMax = 0
  set linhaMax = linhaMax * alturaLinha
  set the locV of sprite spr to 50
  set the locV of sprite spr2 to 50 + numLinhas * alturaLinha
  set ultimoScroll = the timer
  set lastOut = true
  --  set the visibility of sprite spr to false
  --  set ligado = false
  set modificouCursor = false
  set numCursor = 1
end

on idleSprite me
  if not the visible of sprite spr then return
  
  global gMustUpdate
  
  --  if not ligado then
  --    set the visibility of sprite spr to true
  --    set ligado = true
  --    set gMustUpdate = true
  --  end if
  
  -- Verifica se mouse passa por cima do texto
  global gCritico
  set mh = the mouseH
  set mv = the mouseV
  set m = point(mh,mv)
  if not inside(m,rect(30,50,310,430)) or gCritico > 0 then
    set lastOut = true
    if modificouCursor then 
      cursor -1
      set modificouCursor = false
    end if
    return
  end if
  
  
  global gCritico, gMustUpdate
  set y = the mouseV
  
  -- Calcula velocidade conforme posicao do mouse
  set v = 0
  set y = y - 50
  if (y < areaSensivel) then 
    set v = -( (areaSensivel - y) * (velMax - velMin) / areaSensivel + velMin )
  else 
    set y = 380 - y
    if (y < areaSensivel) then
      set v = (areaSensivel - y) * (velMax - velMin) / areaSensivel + velMin
    end if
  end if
  if v = 0 then 
    if not lastOut then set lastOut = true
    if modificouCursor then 
      cursor -1
      set modificouCursor = false
    end if
    return
  end if  
  
  -- Calcula delta de linhas
  if lastOut then
    set lastOut = false
    set ultimoScroll = the timer
    return
  end if
  set dl = (the timer - ultimoScroll) * v / 60
  if dl > 0 and linhaAtual = linhaMax then set dl = 0
  else if dl < 0 and linhaAtual = 0 then set dl = 0
  
  if dl = 0 then 
    if modificouCursor then 
      cursor -1
      set modificouCursor = false
    end if
    return
  end if
  
  if dl > 0 then 
    cursor [the number of member ("CursorBaixo" & numCursor),¬
            the number of member "CursorMask"]
    set numCursor = 3 - numCursor
    set modificouCursor = true
    if dl > puloMax then 
      set dl = puloMax
    end if
  else
    cursor [the number of member ("CursorCima" & numCursor),¬
            the number of member "CursorMask"]
    set numCursor = 3 - numCursor
    set modificouCursor = true
    if dl < - puloMax then
      set dl = - puloMax
    end if
  end if
  set ultimoScroll = the timer
  
  -- Calcula nova linha
  set l = linhaAtual + dl
  if l < 0 then set l = 0
  else if l > linhaMax then
    set dl = dl + linhaMax
    set l = linhaMax
  end if
  
  if l <> linhaAtual then
    set the locV of sprite spr to 50 - l
    set the locV of sprite spr2 to 50 - l +  numLinhas * alturaLinha 
    set gMustUpdate = true
    repeat with i = 1 to count(interessados)
      sendSprite(getAt(interessados,i), #scrollLinha, l - linhaAtual)
    end repeat
    set linhaAtual = l
  end if
end

on mouseUp me
  set y = the mouseV
  set dl = 0
  
  -- Calcula velocidade conforme posicao do mouse
  set y = y - 50
  if (y < areaSensivel and linhaAtual > 0) then 
    puppetSound 2, "Warp1"
    -- Scroll page down
    set dl = - 300
  else 
    set y = 380 - y
    if (y < areaSensivel and linhaAtual < linhaMax) then
      puppetSound 2, "Warp2"
      -- Scroll page up
      set dl = + 300
    end if
  end if
  
  if dl = 0 then return
  
  -- Calcula nova linha
  set l = linhaAtual + dl
  if l < 0 then set l = 0
  else if l > linhaMax then
    set l = linhaMax
  end if
  
  if l <> linhaAtual then
    set the locV of sprite spr to 50 - l
    set the locV of sprite spr2 to 50 - l +  numLinhas * alturaLinha 
    repeat with i = 1 to count(interessados)
      sendSprite(getAt(interessados,i), #scrollLinha, l - linhaAtual)
    end repeat
    set linhaAtual = l
  end if
  
  updateStage
  
  stopEvent
end

-- Para clicks de scroll de pagina de fora
on tentaScroll me
  set scrolou = false
  set y = the mouseV
  set dl = 0
  
  -- Calcula velocidade conforme posicao do mouse
  set y = y - 50
  if (y < areaSensivel and linhaAtual > 0) then 
    puppetSound 2, "Warp1"
    -- Scroll page down
    set dl = - 300
  else 
    set y = 380 - y
    if (y < areaSensivel and linhaAtual < linhaMax) then
      puppetSound 2, "Warp2"
      -- Scroll page up
      set dl = + 300
    end if
  end if
  
  if dl = 0 then return
  
  -- Calcula nova linha
  set l = linhaAtual + dl
  if l < 0 then set l = 0
  else if l > linhaMax then
    set l = linhaMax
  end if
  
  if l <> linhaAtual then
    set the locV of sprite spr to 50 - l
    set the locV of sprite spr2 to 50 - l +  numLinhas * alturaLinha 
    repeat with i = 1 to count(interessados)
      sendSprite(getAt(interessados,i), #scrollLinha, l - linhaAtual)
    end repeat
    set linhaAtual = l
  end if
  
  updateStage
  set scrolou = true
end