property memSom
property ligado
property tempoIn
property minTocando, maxTocando
property memoria, limitado

on getBehaviorDescription
  return "Faz busca automatica de palavra clicada"
end

on getPropertyDescriptionList
  set p_list = [ ¬
    #memSom: [ #comment:   "Membro que contem som",¬
                 #format:   #string, ¬
                 #default:    "MembroSom" ],¬
    #tempoIn: [ #comment:   "Tempo de fadeIn",¬
                 #format:   #integer, ¬
                 #default:  120 ],¬
    #minTocando: [ #comment:   "Tempo minimo que o som fica tocando",¬
                 #format:   #integer, ¬
                 #default:     300],¬
    #maxTocando: [ #comment:   "Tempo maximo que o som fica tocando",¬
                 #format:   #integer, ¬
                 #default:  800 ],¬
    #memoria: [ #comment:   "Memoria minima para tocar este som",¬
                 #format:   #integer, ¬
                 #default:  0 ]¬
  ]
  return p_list
end

on beginSprite me
  global myMemSize
  if memoria * 1024 * 1024 > myMemSize then
    set limitado = true
  else 
    set limitado = false
    set ligado = false
    if the number of member memSom <> -1 then
      preloadMember member memSom
    end if
  end if
end

on cleanSprite me
  if (not limitado) and ligado then
    global gFundoTempo
    sound fadeOut 1, tempoIn
    set gFundoTempo = the timer + tempoIn + 30
    set ligado = false
  end if
end

on idleSprite me
  if limitado then return
  global gMustUpdate
  global gFundoTempo  
  if ligado then
    if the timer >= gFundoTempo then
      if soundBusy(1) then sound fadeOut 1, tempoIn
      set gMustUpdate to true
      set ligado = false
      set gFundoTempo = the timer + tempoIn + random(maxTocando - minTocando) + minTocando
    end if
    
  else -- Som desligado, espera o tempo para religar
    if the timer >= gFundoTempo then
      set gMustUpdate to true
      puppetSound 1,  0
      updateStage
      set the volume of sound 1 to 255
      updateStage
      if the number of member memSom <> -1 then
        puppetSound 1, memSom
      end if
      sound fadeIn 1, tempoIn
      set ligado = true
      set gFundoTempo = the timer + random(maxTocando - minTocando) + minTocando
    end if
  end if
end