property memSomPrim, memSomUlt, memPrim, memQuantos
property ligado
property tempoIn
property minTocando, maxTocando
property 

on getBehaviorDescription
  return "Faz busca automatica de palavra clicada"
end

on getPropertyDescriptionList
  set p_list = [ ¬
    #memSomPrim: [ #comment:   "Primeiro membro que contem som",¬
                 #format:   #string, ¬
                 #default:    "MembroSom" ],¬
    #memSomUlt: [ #comment:   "Ultimo membro que contem som",¬
                 #format:   #string, ¬
                 #default:    "MembroSom" ],¬
    #tempoIn: [ #comment:   "Tempo de fadeIn",¬
                 #format:   #integer, ¬
                 #default:  120 ],¬
    #minTocando: [ #comment:   "Tempo minimo que o som fica tocando",¬
                 #format:   #integer, ¬
                 #default:     300],¬
    #maxTocando: [ #comment:   "Tempo maximo que o som fica tocando",¬
                 #format:   #integer, ¬
                 #default:  800 ]¬
  ]
  return p_list
end

on beginSprite me
  set ligado = false
  set memPrim = the number of member memSomPrim
  set memQuantos = (the number of member memSomUlt) - memPrim + 1
end

on cleanSprite me
  if ligado then
    global gFundoTempo
    sound fadeOut 1, tempoIn
    set gFundoTempo = the timer + tempoIn + 30
    set ligado = false
  end if
end

on idleSprite me
  global gMustUpdate
  global gFundoTempo  
  if ligado then
    if the timer >= gFundoTempo then
      if soundBusy(1) then sound fadeOut 1, tempoIn
      set gMustUpdate to true
      set ligado = false
      set gFundoTempo = the timer + tempoIn + random(maxTocando - minTocando) + minTocando
    end if
    
  else -- Som desligado, espera o tempo para religar
    if the timer >= gFundoTempo then
      puppetSound 1, 0
      updateStage
      set the volume of sound 1 to 255
      updateStage
      set gMustUpdate to true
      if memPrim >= 0 then
        --set num_mem = (memPrim + random(memQuantos) - 1)
        set num_mem = memPrim
        puppetSound 1, num_mem
      end if
      sound fadeIn 1, tempoIn
      set ligado = true
      set gFundoTempo = the timer + random(maxTocando - minTocando) + minTocando
    end if
  end if
end